<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0">

  <xsl:param name="types"/>

  <!-- Add or process type elements inside item elements. -->

  <xsl:template match="item">
    <!-- Copy the element and its contents. -->
    <xsl:copy>
      <xsl:apply-templates select="@*"/>
      <!-- Look for a type element. -->
      <xsl:call-template name="type"/>
      <xsl:apply-templates select="*[local-name() != 'type']"/>
    </xsl:copy>
  </xsl:template>

  <!-- Investigate type elements. -->

  <xsl:template name="type">
    <!-- Make the element. -->
    <type>
      <xsl:apply-templates select="type/@*"/>
      <xsl:call-template name="type-enum"/>
    </type>
  </xsl:template>

  <!-- Add to type elements the range of acceptable values. -->

  <xsl:template name="type-enum">
    <!-- Find all values in the range and add them. -->
    <xsl:for-each select="$types/types/type-enum">
      <xsl:copy>
        <xsl:apply-templates select="@*"/>
      </xsl:copy>
    </xsl:for-each>
  </xsl:template>

  <!-- Replicate unknown elements. -->

  <xsl:template match="@*|*|node()">
    <xsl:copy>
      <xsl:apply-templates select="@*|*|node()"/>
    </xsl:copy>
  </xsl:template>

</xsl:stylesheet>
